#ifndef ACSCOURSE_PSIMPL_H_
#define ACSCOURSE_PSIMPL_H_
/*******************************************************************************
*    ALMA - Atacama Large Millimiter Array
*    (c) European Southern Observatory, 2002
*    Copyright by ESO (in the framework of the ALMA collaboration)
*    and Cosylab 2002, All rights reserved
*
*    This library is free software; you can redistribute it and/or
*    modify it under the terms of the GNU Lesser General Public
*    License as published by the Free Software Foundation; either
*    version 2.1 of the License, or (at your option) any later version.
*
*    This library is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*    Lesser General Public License for more details.
*
*    You should have received a copy of the GNU Lesser General Public
*    License along with this library; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

*/

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

///Contains the defintion of the standard superclass for C++ components
#include <acscomponentImpl.h>

///CORBA generated servant stub
#include <acscourseAlarmsS.h>


using namespace acscomponent;


class PS: public ACSComponentImpl,     
			     public virtual POA_acscourse::PS
{
  public:
     /**
     * Constructor
     */
    PS(const ACE_CString &name,maci::ContainerServices * containerServices);
    
    /**
     * Destructor
     */
    virtual ~PS();
    
    /**
     * Simulate the lost of power
     */
    void cutOff() throw (CORBA::SystemException );
    
    /**
     * The power has been turned on again
     */                                                                                                                
    void powerOn() throw (CORBA::SystemException );
    
    // Life cycle methods
    virtual void initialize() throw (ACSErr::ACSbaseExImpl);
    virtual void execute()  throw (ACSErr::ACSbaseExImpl);
    virtual void cleanUp();
    virtual void aboutToAbort();
    
  private:
    // ContainerServices
    maci::ContainerServices * m_conSvcs;
    // The mount component
    acscourse::Mount_var mount;
};

#endif // ACSCOURSE_PSIMPL_H_
