package alma.acscourse.mount;

import alma.acs.component.ComponentImplBase;
import alma.acscourse.MountOperations;
import alma.acscourse.Antenna;
import alma.acscourse.AntennaOperations;
import alma.acscourse.AntennaHelper;

import alma.alarmsystem.source.ACSAlarmSystemInterfaceFactory;
import alma.alarmsystem.source.ACSFaultState;
import alma.alarmsystem.source.ACSAlarmSystemInterface;
import java.sql.Timestamp;
import java.util.Properties;

class MountImpl extends ComponentImplBase implements MountOperations {
	Antenna antenna;
	public void powerOff() {
		// Send the alarm (mount not working)
		
		// Simulate the failure calling the faultMount method in the antenna
		try { 
			Thread.sleep(5000);
		} catch (Exception e) {}
		Antenna ant = getAntenna();
		if (ant!=null) {
			ant.faultMount();
		}
	}
	
	public void powerOn() {
		//	Send the termination alarm (mount working)
		
		// Communicate to the Antenna that the mount is now working
		try { 
			Thread.sleep(5000);
		} catch (Exception e) {}
		Antenna ant = getAntenna();
		if (ant!=null) {
			ant.mountFixed();
		}
	}
	
	private Antenna getAntenna() {
		if (this.antenna==null) {
			org.omg.CORBA.Object cmp = null;
			try
			{
				cmp = m_containerServices.getComponent("ALARM_COURSE_ANTENNA");
				antenna = AntennaHelper.narrow(cmp);
			}
			catch (Exception ex)
			{}
		}
		return antenna;
	}
}
